=== linux_linker/CMakeLists.txt ===
ADD_EXECUTABLE(linux_resource_linker linux_resource_linker)
